---
# Cop supports --autocorrect.
RSpec/ScatteredLet:
  Exclude:
    - 'ee/spec/graphql/types/vulnerability_evidence_supporting_message_type_spec.rb'
    - 'ee/spec/graphql/types/vulnerability_evidence_type_spec.rb'
    - 'ee/spec/graphql/types/vulnerability_request_response_header_type_spec.rb'
    - 'ee/spec/graphql/types/vulnerability_request_type_spec.rb'
    - 'ee/spec/graphql/types/vulnerability_response_type_spec.rb'
    - 'ee/spec/helpers/ee/integrations_helper_spec.rb'
    - 'ee/spec/helpers/ee/subscribable_banner_helper_spec.rb'
    - 'ee/spec/lib/audit/external_status_check_changes_auditor_spec.rb'
    - 'ee/spec/lib/ee/api/helpers/members_helpers_spec.rb'
    - 'ee/spec/lib/gitlab/ci/parsers/security/dast_spec.rb'
    - 'ee/spec/lib/gitlab/code_owners/loader_spec.rb'
    - 'ee/spec/lib/gitlab/cycle_analytics/stage_summary_spec.rb'
    - 'ee/spec/lib/gitlab/elastic/bulk_indexer_spec.rb'
    - 'ee/spec/lib/gitlab/geo/replication/blob_downloader_spec.rb'
    - 'ee/spec/lib/gitlab/git_access_spec.rb'
    - 'ee/spec/lib/gitlab/insights/reducers/count_per_label_reducer_spec.rb'
    - 'ee/spec/lib/gitlab/insights/reducers/label_count_per_period_reducer_spec.rb'
    - 'ee/spec/lib/gitlab/usage/metrics/instrumentations/approval_project_rules_with_user_metric_spec.rb'
    - 'ee/spec/lib/gitlab/usage_data_metrics_spec.rb'
    - 'ee/spec/models/approval_wrapped_any_approver_rule_spec.rb'
    - 'ee/spec/models/dast_site_validation_spec.rb'
    - 'ee/spec/models/ee/ci/build_dependencies_spec.rb'
    - 'ee/spec/models/ee/user_spec.rb'
    - 'ee/spec/models/epic_spec.rb'
    - 'ee/spec/models/iteration_spec.rb'
    - 'ee/spec/models/preloaders/environments/protected_environment_preloader_spec.rb'
    - 'ee/spec/models/vulnerabilities/historical_statistic_spec.rb'
    - 'ee/spec/requests/api/analytics/project_deployment_frequency_spec.rb'
    - 'ee/spec/requests/api/graphql/compliance_management/merge_requests/compliance_violations_spec.rb'
    - 'ee/spec/requests/api/graphql/group/ci_cd_settings_spec.rb'
    - 'ee/spec/requests/api/graphql/group/epic/notes_spec.rb'
    - 'ee/spec/requests/api/graphql/instance_security_dashboard_spec.rb'
    - 'ee/spec/requests/api/graphql/mutations/incident_management/oncall_rotation/update_spec.rb'
    - 'ee/spec/requests/api/graphql/mutations/projects/set_compliance_framework_spec.rb'
    - 'ee/spec/requests/api/graphql/mutations/security/finding/create_issue_spec.rb'
    - 'ee/spec/requests/api/graphql/project/dast_profile_schedule_spec.rb'
    - 'ee/spec/requests/api/graphql/project/environments_spec.rb'
    - 'ee/spec/requests/api/graphql/project/pipeline/dast_profile_spec.rb'
    - 'ee/spec/requests/api/graphql/project/pipeline/security_report_summary_spec.rb'
    - 'ee/spec/requests/api/graphql/project/pipelines/dast_profile_spec.rb'
    - 'ee/spec/requests/api/graphql/project/requirements_management/requirements_spec.rb'
    - 'ee/spec/requests/api/graphql/project/requirements_management/test_reports_spec.rb'
    - 'ee/spec/requests/api/graphql/vulnerabilities/details_spec.rb'
    - 'ee/spec/requests/api/group_boards_spec.rb'
    - 'ee/spec/requests/api/project_push_rule_spec.rb'
    - 'ee/spec/requests/api/settings_spec.rb'
    - 'ee/spec/services/analytics/devops_adoption/snapshots/calculate_and_save_service_spec.rb'
    - 'ee/spec/services/app_sec/dast/scan_configs/fetch_service_spec.rb'
    - 'ee/spec/services/arkose/blocked_users_report_service_spec.rb'
    - 'ee/spec/services/audit_event_service_spec.rb'
    - 'ee/spec/services/boards/epics/move_service_spec.rb'
    - 'ee/spec/services/compliance_management/frameworks/create_service_spec.rb'
    - 'ee/spec/services/compliance_management/frameworks/update_service_spec.rb'
    - 'ee/spec/services/concerns/epics/related_epic_links/usage_data_helper_spec.rb'
    - 'ee/spec/services/ee/issue_links/create_service_spec.rb'
    - 'ee/spec/services/ee/issues/create_service_spec.rb'
    - 'ee/spec/services/ee/merge_requests/base_service_spec.rb'
    - 'ee/spec/services/ee/merge_requests/update_reviewers_service_spec.rb'
    - 'ee/spec/services/epic_issues/create_service_spec.rb'
    - 'ee/spec/services/epics/issue_promote_service_spec.rb'
    - 'ee/spec/services/geo/metrics_update_service_spec.rb'
    - 'ee/spec/services/group_saml/saml_provider/create_service_spec.rb'
    - 'ee/spec/services/group_saml/saml_provider/update_service_spec.rb'
    - 'ee/spec/services/groups/memberships/export_service_spec.rb'
    - 'ee/spec/services/incident_management/escalation_policies/create_service_spec.rb'
    - 'ee/spec/services/incident_management/oncall_rotations/remove_participant_service_spec.rb'
    - 'ee/spec/services/members/activate_service_spec.rb'
    - 'ee/spec/services/personal_access_tokens/groups/update_lifetime_service_spec.rb'
    - 'ee/spec/services/security/report_summary_service_spec.rb'
    - 'ee/spec/services/vulnerabilities/security_finding/create_issue_service_spec.rb'
    - 'ee/spec/workers/concerns/update_orchestration_policy_configuration_spec.rb'
    - 'spec/controllers/concerns/metrics_dashboard_spec.rb'
    - 'spec/controllers/import/bitbucket_server_controller_spec.rb'
    - 'spec/controllers/projects/deploy_keys_controller_spec.rb'
    - 'spec/controllers/projects/environments_controller_spec.rb'
    - 'spec/controllers/projects/issues_controller_spec.rb'
    - 'spec/controllers/projects/jobs_controller_spec.rb'
    - 'spec/features/boards/user_visits_board_spec.rb'
    - 'spec/features/groups/dependency_proxy_for_containers_spec.rb'
    - 'spec/features/issues/user_filters_issues_spec.rb'
    - 'spec/finders/concerns/finder_with_cross_project_access_spec.rb'
    - 'spec/finders/group_projects_finder_spec.rb'
    - 'spec/finders/groups/user_groups_finder_spec.rb'
    - 'spec/finders/license_template_finder_spec.rb'
    - 'spec/finders/projects/groups_finder_spec.rb'
    - 'spec/frontend/fixtures/jobs.rb'
    - 'spec/graphql/resolvers/clusters/agents_resolver_spec.rb'
    - 'spec/graphql/resolvers/concerns/looks_ahead_spec.rb'
    - 'spec/graphql/resolvers/concerns/resolves_project_spec.rb'
    - 'spec/graphql/resolvers/design_management/version_in_collection_resolver_spec.rb'
    - 'spec/graphql/resolvers/group_milestones_resolver_spec.rb'
    - 'spec/graphql/resolvers/users/groups_resolver_spec.rb'
    - 'spec/graphql/types/base_object_spec.rb'
    - 'spec/graphql/types/ci/job_token_scope_type_spec.rb'
    - 'spec/graphql/types/environment_type_spec.rb'
    - 'spec/graphql/types/project_type_spec.rb'
    - 'spec/graphql/types/terraform/state_version_type_spec.rb'
    - 'spec/graphql/types/user_type_spec.rb'
    - 'spec/helpers/blob_helper_spec.rb'
    - 'spec/helpers/merge_requests_helper_spec.rb'
    - 'spec/lib/atlassian/jira_connect/jwt/asymmetric_spec.rb'
    - 'spec/lib/banzai/filter/references/project_reference_filter_spec.rb'
    - 'spec/lib/banzai/filter/references/user_reference_filter_spec.rb'
    - 'spec/lib/banzai/reference_parser/alert_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/commit_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/commit_range_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/design_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/external_issue_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/label_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/merge_request_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/milestone_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/project_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/snippet_parser_spec.rb'
    - 'spec/lib/banzai/reference_parser/user_parser_spec.rb'
    - 'spec/lib/bulk_imports/groups/pipelines/subgroup_entities_pipeline_spec.rb'
    - 'spec/lib/bulk_imports/pipeline/runner_spec.rb'
    - 'spec/lib/bulk_imports/projects/pipelines/snippets_repository_pipeline_spec.rb'
    - 'spec/lib/gitlab/asciidoc/include_processor_spec.rb'
    - 'spec/lib/gitlab/auth/ldap/person_spec.rb'
    - 'spec/lib/gitlab/auth/saml/auth_hash_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_imported_issue_search_data_spec.rb'
    - 'spec/lib/gitlab/background_migration/disable_legacy_open_source_license_for_inactive_public_projects_spec.rb'
    - 'spec/lib/gitlab/background_migration/legacy_uploads_migrator_spec.rb'
    - 'spec/lib/gitlab/background_migration/nullify_orphan_runner_id_on_ci_builds_spec.rb'
    - 'spec/lib/gitlab/background_migration/reset_too_many_tags_skipped_registry_imports_spec.rb'
    - 'spec/lib/gitlab/background_migration/update_jira_tracker_data_deployment_type_based_on_url_spec.rb'
    - 'spec/lib/gitlab/checks/matching_merge_request_spec.rb'
    - 'spec/lib/gitlab/ci/config/external/file/artifact_spec.rb'
    - 'spec/lib/gitlab/ci/config_spec.rb'
    - 'spec/lib/gitlab/ci/pipeline/chain/helpers_spec.rb'
    - 'spec/lib/gitlab/ci/status/stage/factory_spec.rb'
    - 'spec/lib/gitlab/ci/yaml_processor_spec.rb'
    - 'spec/lib/gitlab/cycle_analytics/stage_summary_spec.rb'
    - 'spec/lib/gitlab/database/background_migration/batched_migration_spec.rb'
    - 'spec/lib/gitlab/database/partitioning/partition_manager_spec.rb'
    - 'spec/lib/gitlab/database/postgresql_adapter/empty_query_ping_spec.rb'
    - 'spec/lib/gitlab/database/reindexing/grafana_notifier_spec.rb'
    - 'spec/lib/gitlab/diff/file_collection/merge_request_diff_batch_spec.rb'
    - 'spec/lib/gitlab/diff/formatters/text_formatter_spec.rb'
    - 'spec/lib/gitlab/diff/position_spec.rb'
    - 'spec/lib/gitlab/diff/position_tracer/image_strategy_spec.rb'
    - 'spec/lib/gitlab/diff/position_tracer/line_strategy_spec.rb'
    - 'spec/lib/gitlab/diff/suggestion_diff_spec.rb'
    - 'spec/lib/gitlab/diff/suggestion_spec.rb'
    - 'spec/lib/gitlab/error_tracking/processor/context_payload_processor_spec.rb'
    - 'spec/lib/gitlab/git/blame_spec.rb'
    - 'spec/lib/gitlab/git/diff_collection_spec.rb'
    - 'spec/lib/gitlab/git_access_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/single_endpoint_issue_events_importer_spec.rb'
    - 'spec/lib/gitlab/import_export/group/relation_tree_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/project/relation_tree_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/project/sample/relation_tree_restorer_spec.rb'
    - 'spec/lib/gitlab/jira_import/issue_serializer_spec.rb'
    - 'spec/lib/gitlab/lets_encrypt/client_spec.rb'
    - 'spec/lib/gitlab/metrics/dashboard/stages/grafana_formatter_spec.rb'
    - 'spec/lib/gitlab/metrics/subscribers/external_http_spec.rb'
    - 'spec/lib/gitlab/middleware/memory_report_spec.rb'
    - 'spec/lib/gitlab/pagination/keyset/page_spec.rb'
    - 'spec/lib/gitlab/pagination/offset_pagination_spec.rb'
    - 'spec/lib/gitlab/patch/database_config_spec.rb'
    - 'spec/lib/gitlab/path_regex_spec.rb'
    - 'spec/lib/gitlab/prometheus/queries/matched_metric_query_spec.rb'
    - 'spec/lib/gitlab/relative_positioning/item_context_spec.rb'
    - 'spec/lib/gitlab/relative_positioning/mover_spec.rb'
    - 'spec/lib/gitlab/serializer/pagination_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/extra_done_log_metadata_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/size_limiter/validator_spec.rb'
    - 'spec/lib/gitlab/template/finders/global_template_finder_spec.rb'
    - 'spec/lib/gitlab/tree_summary_spec.rb'
    - 'spec/lib/gitlab/usage/metrics/instrumentations/gitlab_for_jira_app_proxy_installations_count_metric_spec.rb'
    - 'spec/lib/gitlab/usage_data_metrics_spec.rb'
    - 'spec/lib/gitlab/utils/measuring_spec.rb'
    - 'spec/lib/gitlab/zentao/client_spec.rb'
    - 'spec/lib/peek/views/external_http_spec.rb'
    - 'spec/mailers/notify_spec.rb'
    - 'spec/mailers/previews_spec.rb'
    - 'spec/migrations/20220329175119_remove_leftover_ci_job_artifact_deletions_spec.rb'
    - 'spec/models/ci/bridge_spec.rb'
    - 'spec/models/ci/build_dependencies_spec.rb'
    - 'spec/models/ci/pipeline_spec.rb'
    - 'spec/models/concerns/issuable_spec.rb'
    - 'spec/models/concerns/manual_inverse_association_spec.rb'
    - 'spec/models/concerns/noteable_spec.rb'
    - 'spec/models/deploy_keys_project_spec.rb'
    - 'spec/models/design_management/design_at_version_spec.rb'
    - 'spec/models/diff_note_spec.rb'
    - 'spec/models/integration_spec.rb'
    - 'spec/models/merge_request_spec.rb'
    - 'spec/models/push_event_spec.rb'
    - 'spec/models/ssh_host_key_spec.rb'
    - 'spec/models/users/credit_card_validation_spec.rb'
    - 'spec/models/wiki_page_spec.rb'
    - 'spec/policies/group_member_policy_spec.rb'
    - 'spec/requests/admin/background_migrations_controller_spec.rb'
    - 'spec/requests/api/ci/jobs_spec.rb'
    - 'spec/requests/api/ci/pipeline_schedules_spec.rb'
    - 'spec/requests/api/commit_statuses_spec.rb'
    - 'spec/requests/api/graphql/ci/runners_spec.rb'
    - 'spec/requests/api/graphql/group/work_item_types_spec.rb'
    - 'spec/requests/api/graphql/milestone_spec.rb'
    - 'spec/requests/api/graphql/mutations/boards/create_spec.rb'
    - 'spec/requests/api/graphql/mutations/work_items/delete_task_spec.rb'
    - 'spec/requests/api/graphql/namespace/projects_spec.rb'
    - 'spec/requests/api/graphql/project/deployment_spec.rb'
    - 'spec/requests/api/graphql/project/environments_spec.rb'
    - 'spec/requests/api/graphql/project/issue/design_collection/version_spec.rb'
    - 'spec/requests/api/graphql/project/issue/design_collection/versions_spec.rb'
    - 'spec/requests/api/graphql/project/issue_spec.rb'
    - 'spec/requests/api/graphql/project/jira_projects_spec.rb'
    - 'spec/requests/api/graphql/project/merge_request/diff_notes_spec.rb'
    - 'spec/requests/api/graphql/project/milestones_spec.rb'
    - 'spec/requests/api/graphql/project/work_item_types_spec.rb'
    - 'spec/requests/api/graphql/todo_query_spec.rb'
    - 'spec/requests/api/group_boards_spec.rb'
    - 'spec/requests/api/issues/get_group_issues_spec.rb'
    - 'spec/requests/api/merge_requests_spec.rb'
    - 'spec/requests/api/notes_spec.rb'
    - 'spec/requests/api/project_clusters_spec.rb'
    - 'spec/requests/jira_routing_spec.rb'
    - 'spec/serializers/build_details_entity_spec.rb'
    - 'spec/serializers/ci/job_entity_spec.rb'
    - 'spec/serializers/merge_requests/pipeline_entity_spec.rb'
    - 'spec/services/ci/create_downstream_pipeline_service_spec.rb'
    - 'spec/services/ci/create_pipeline_service/rules_spec.rb'
    - 'spec/services/ci/create_pipeline_service_spec.rb'
    - 'spec/services/ci/destroy_pipeline_service_spec.rb'
    - 'spec/services/design_management/delete_designs_service_spec.rb'
    - 'spec/services/design_management/save_designs_service_spec.rb'
    - 'spec/services/discussions/capture_diff_note_positions_service_spec.rb'
    - 'spec/services/events/destroy_service_spec.rb'
    - 'spec/services/git/base_hooks_service_spec.rb'
    - 'spec/services/issues/create_service_spec.rb'
    - 'spec/services/merge_requests/mergeability/logger_spec.rb'
    - 'spec/services/merge_requests/update_assignees_service_spec.rb'
    - 'spec/services/merge_requests/update_reviewers_service_spec.rb'
    - 'spec/services/metrics/dashboard/custom_metric_embed_service_spec.rb'
    - 'spec/services/metrics/dashboard/dynamic_embed_service_spec.rb'
    - 'spec/services/metrics/dashboard/gitlab_alert_embed_service_spec.rb'
    - 'spec/services/metrics/dashboard/grafana_metric_embed_service_spec.rb'
    - 'spec/services/notification_service_spec.rb'
    - 'spec/services/packages/composer/create_package_service_spec.rb'
    - 'spec/services/packages/conan/create_package_file_service_spec.rb'
    - 'spec/services/packages/debian/create_distribution_service_spec.rb'
    - 'spec/services/packages/debian/create_package_file_service_spec.rb'
    - 'spec/services/packages/debian/generate_distribution_key_service_spec.rb'
    - 'spec/services/packages/debian/update_distribution_service_spec.rb'
    - 'spec/services/projects/lfs_pointers/lfs_download_link_list_service_spec.rb'
    - 'spec/services/snippets/create_service_spec.rb'
    - 'spec/services/suggestions/create_service_spec.rb'
    - 'spec/services/system_notes/design_management_service_spec.rb'
    - 'spec/services/system_notes/merge_requests_service_spec.rb'
    - 'spec/services/system_notes/time_tracking_service_spec.rb'
    - 'spec/services/todo_service_spec.rb'
    - 'spec/support/shared_examples/graphql/sorted_paginated_query_shared_examples.rb'
    - 'spec/tasks/gitlab/artifacts/migrate_rake_spec.rb'
    - 'spec/workers/environments/auto_stop_worker_spec.rb'
    - 'spec/workers/packages/debian/generate_distribution_worker_spec.rb'
